/* ianymatch.c */
/********************************************
* find string in buffer
* Istvan Mohos, 1987 --- in the Public Domain
*********************************************/

#include "i.h"

char *
ianymatch (start, end, str)
char *start;
char *end, *str;
{
	register char *off;
	char *tail;
	char *sc, *tc;
	register char *pp, *wp;
	int length;

	if (NULCHARP (start) || BADCHARP (str)) {
		ierror("ianymatch: invalid parameters");
		return(NULL);
	}
	ITOEND;

	for (sc = off = str; *off++;);
	length = --off - str;
	tc = --off;

	off = end;

	for (off -= --length; start < off;) {
		tail = start + length;
		if (*start++ == *sc && *tail == *tc) {
			if (length > 1) {
				for (wp = tc, pp = tail; *--wp == *--pp;)
					if (pp == start)
						return(--start);
			}
			else
				return(--start);
		}
	}
	return(NULL);
}
