/* idump.c */
/*****************************************
* write a buffer to stdout, show NUL bytes
* Istvan Mohos, 1987 --- in the Public Domain
*****************************************/

#include "i.h"

void
idump (start, end, ch)
char *start;
register char *end;
char ch;
{
	register char *ptr1, *ptr2;
	char *cp = &ch;

	if (NULCHARP (start))
		return;
	ITOEND;

	for (ptr1 = ptr2 = start; ptr1 < end; ptr1++) {
		if (!*ptr1) {
			write(1, ptr2, ptr1-ptr2);
			ptr2 = ptr1 + 1;
			write(1, cp, 1);
		}
	}
	if (ptr1 != ptr2)
		write(1, ptr2, ptr1-ptr2);
}
