/* ifilter.c */
/**************************************************************
* read file or stdin into buffer at mallocp, return buffer size
* Istvan Mohos, 1989 --- in the Public Domain
**************************************************************/

#include "i.h"

int
ifilter (fname, mallocp)
char *fname;
char **mallocp;
{
	char *realloc();
	char *bufptr;
	register int bytes;
	register int count = 0;

	/* if no file name, read from stdin 'till EOF */
	if (NULCHARP (fname)) {
		if (NULCHARP (*mallocp = malloc (BUFSIZ)))
			return (ierror ("ifilter: can't allocate filter buffer"));
		for (bufptr = *mallocp;
			(bytes = fread (bufptr, 1, BUFSIZ, stdin)) > 0;) {
			count += bytes;
			if (NULCHARP (*mallocp = realloc (*mallocp, count+BUFSIZ)))
				return (ierror ("ifilter: can't realloc filter buffer"));
			bufptr = *mallocp + count;
		}
		*bufptr = '\0';
		return (count);
	}

	return (iread (fname, mallocp));
}
