/* ihasharg.c */
/************************************************
* hash last component (command name) of file name
* Istvan Mohos, 1987 --- in the Public Domain
************************************************/

#include "i.h"

int
ihasharg(ptr, delim)
char *ptr, delim;
{
	register char *hip;
	register int hashval = 0;

	if (BADCHARP(ptr))
		return(ierror("ihasharg: bad buffer"));

	if (!delim)
		delim = '/';
	for (hip = ptr; *hip++;);
	for(--hip;--hip > ptr;) {
		if (*hip == delim) {
			++hip;
			break;
		}
	}
	if (*hip == delim)
		++hip;
	for(;*hip;)
		hashval += (*hip++ & 95);

	return(hashval);
}
