/* ilongest.c */
/*****************************************
* count lines, find longest line in buffer
* Istvan Mohos, 1987 --- in the Public Domain
*****************************************/

#include "i.h"

int
ilongest (start, end, lcount)
register char *start, *end;
int *lcount;
{
	register char *here, *behind;
	int length;
	int count = 0;
	int longest = 0;

	if (NULCHARP (start))
		return (ierror ("ilongest: null buffer"));
	ITOEND;

	for (here = behind = start; here < end; here++) {
		if (*here == '\n' || *here == '\0') {
			length = here - behind;
			behind = here + 1;
			if (length > longest)
				longest = length;
			++count;
		}
	}

	*lcount = count;
	return(longest);
}
