/* icopy.c */
/**********************************************
* copy buffer into malloc'd buffer, return size
* Istvan Mohos, 1989 --- in the Public Domain
**********************************************/

#include "i.h"

char *
icopy (start, end)
char *start, *end;
{
	char *bp;
	int count;

	if (NULCHARP (start)) {
		ierror ("icopy: null buffer");
		return (NULL);
	}
	ITOEND;

	count = end - start;

	if (NULCHARP (bp = malloc ((unsigned int)count+1))) {
		ierror ("icopy: can't allocate new buffer");
		return (NULL);
	}

	*(bp + count) = 0;
	ibcopy (bp, start, count);

	return (bp);
}
