/* ifamily.c */
/********************************************
* tell if two strings are related
* Istvan Mohos, 1987 --- in the Public Domain
********************************************/

#include "i.h"

int
ifamily (ptr1, ptr2)
register char *ptr1, *ptr2;
{
	if (NULCHARP (ptr1) || NULCHARP (ptr2))
		return (ierror ("ifamily: NULL parameter"));

	for (; *ptr1 && *ptr2; ptr1++, ptr2++)
		if (*ptr1 == *ptr2)
			if (*ptr1 >= '0' && *ptr1 <= '9')
				return (1);
			else
				continue;
		else if (*ptr1 >= '0' && *ptr1 <= '9' &&
				 *ptr2 >= '0' && *ptr2 <= '9')
			return (1);
		else
			return (0);

	if (*ptr1 == *ptr2)
		return (1);

	return (0);
}
