/* ihash.c */
/********************************************
* "hash value" of bytes of string
* Istvan Mohos, 1987 --- in the Public Domain
********************************************/

#include "i.h"

int
ihash(ptr, modval, upcase)
char *ptr;
int modval, upcase;
{
	register char *hip;
	register int hashval = 0;

	if (BADCHARP(ptr))
		return(ierror("ihash: bad buffer"));

	hip = ptr;
	if (upcase)
		for(;*hip;)
			hashval += (*hip++ & 95);
	else
		for(;*hip;)
			hashval += *hip++;

	if (modval)
		hashval %= modval;

	return(hashval);
}
