/* iline.c */
/***************************************************
* find newline in buffer, set to 0, return line size
* Istvan Mohos, 1987 --- in the Public Domain
****************************************************/

#include "i.h"

int
iline (start, end)
register char *start;
register char *end;
{
	register char *off;

	if (NULCHARP (start))
		return (ierror ("iline: null buffer"));
	ITOEND;
	if (end == start)
		return (0);

	for (off = start; off < end; off++)
		if ((*off == '\n' && off == start) ||
			(*off == '\n' && *(off-1) != '\\')) {
			*off = '\0';
			return(off-start+1);
		}

	*--off = '\0'; /* got to end without a newline */
	return(off-start+1);
}
